UNIT GetData;

INTERFACE

uses crt;

type str79=string[79];

FUNCTION GetChar(s:str79):char;
FUNCTION GetString(s,def:str79):str79;
FUNCTION Yes(s:str79):Boolean;
FUNCTION GetReal(s:str79; a:extended):extended;
FUNCTION GetInteger(s:str79; a:longint):longint;
FUNCTION Format(r:extended; i:byte):str79;
FUNCTION UpKey:char;
PROCEDURE Error(s:str79);
PROCEDURE FlushKey;
const PassChar:char=' ';
var LastChar:char;

IMPLEMENTATION

FUNCTION UpKey:char;
BEGIN LastChar:=UpCase(ReadKey); UpKey:=LastChar END;

FUNCTION Yes(s:str79):Boolean;
BEGIN
TextColor(LightMagenta);
write(s,' ? (Y/N/C) ');
TextColor(white);
REPEAT UNTIL UpKey in ['Y','N','C'];
writeln(LastChar);
if LastChar='C' then if Yes('really cancel') then halt;
Yes:=LastChar='Y';
END;

FUNCTION GetChar(s:str79):char;
BEGIN
TextColor(LightCyan);
write(s,' ===>');
writeln(UpKey);
TextColor(white);
GetChar:=LastChar;
END;

FUNCTION GetString(s,def:str79):str79;
BEGIN
TextColor(white);
write(s,' = "',def,'" ===> ');
readln(s);
if s='' then s:=def;
GetString:=s;
END;


FUNCTION format(r:extended; i:byte):str79;
{ i=length of the field. Must be >=8 ! }
var s:str79; b:byte;
BEGIN
if r=0 then s:='    0.0'
else if (abs(r)<1e3) and (abs(r)>=1e-2) then
  BEGIN
  str(r:i:i-5,s);
  while s[length(s)]='0' do dec(s[0]);
  if s[length(s)]='.' then dec(s[0]);
  END
else
  BEGIN
  str(r:i+2,s);
  b:=pos('E+00',s)+pos('E-00',s);
  if b=0 then str(r:i,s)
  else delete(s,b+2,2);
  END;
while length(s)<i do s:=s+' ';
format:=s;
END;

FUNCTION GetReal(s:str79; a:extended):extended;
var
  st:str79;
  er:integer;
BEGIN
if s='' then s:=#4;
GetReal:=a;
if (PassChar<>' ') and (PassChar<>s[1]) then exit;
er:=0;
REPEAT
  TextColor(LightGreen);
  write(s,' =',format(a,12),' ===>');
  TextColor(white);
  readln(st);
  if st<>'' then val(st, a, er)
  UNTIL er=0;
GetReal:=a;
END;

FUNCTION GetInteger(s:str79; a:longint):longint;
var
  st:str79;
  er:integer;
BEGIN
if s='' then s:=#4;
GetInteger:=a;
if (PassChar<>' ') and (PassChar<>s[1]) then exit;
er:=0;
REPEAT
  TextColor(yellow);
  write(s,' = ',a,' ===>');
  TextColor(white);
  readln(st);
  if st<>'' then val(st, a, er)
  UNTIL er=0;
GetInteger:=a;
END;

PROCEDURE Error(s:str79);
BEGIN
TextBackground(red); TextColor(yellow);
write(^g' ERROR ',s); ClrEol;
TextBackground(black); writeln;
if yes('cancel') then halt;
END;

PROCEDURE FlushKey;
BEGIN
while KeyPressed do if ReadKey=#255 then;
END;

END.